%path = "c:\mpa\W7"
%starthist = "1996:1"
%endhist = "2010:1"

cd {%path}

'----- Workfile ----
open kalman

'----- HP filter ----
'graph output_hp lgdp lgdp_tnd_hp
'graph rer_hp lz lz_tnd_hp
'show output_hp rer_hp

'----- KALMAN FILTER -----
vector(9) m_prior
m_prior.fill 10, 0, 0, 0, 375, 4, 2, 5, 1315

sym(9,9) v_prior
v_prior.fill 2, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 3, 0, 0, 0, 1, 0, 0, 3, 0, 3

sspace kalman

kalman.append @signal dl_cpi = dl_cpi_x
kalman.append @signal lgdp = lgdp_tnd + lgdp_gap
kalman.append @signal r = r_tnd + r_gap
kalman.append @signal lz = lz_tnd + lz_gap
kalman.append @signal x_r = x_r_tnd + [var=10]

kalman.append @state dl_cpi_x = 0.5*dl_cpi_x(-1) + (1-0.5)*dl_cpi_tar + x*(x*lgdp_gap(-1)+(1-x)*lz_gap(-1)) + [var = z]
kalman.append @state lgdp_gap =  x*lgdp_gap(-1) - x*r_gap(-1) + x*lz_gap(-1) + [var = z]

kalman.append @state r_gap = x*r_gap(-1) + [var = z]
kalman.append @state lz_gap = x*lz_gap(-1) + [var = z]

kalman.append @state lz_tnd = lz_tnd(-1) + r_tnd(-1)/4 - x_r_tnd(-1)/4 - prem(-1)/4

kalman.append @state r_tnd = r_tnd(-1) + [var = z]
kalman.append @state x_r_tnd = 0.5*x_r_tnd(-1) + (1-0.5)*2 + [var = z]
kalman.append @state prem = prem(-1) + [var =  z]
kalman.append @state lgdp_tnd = lgdp_tnd(-1) + x/4 + [var = z]

kalman.append @mprior m_prior
kalman.append @vprior v_prior

kalman.ml

kalman.makestates(t=smooth) *_k
rename *_k *

'----- Graphs -----
graph output lgdp lgdp_tnd
graph rir r r_tnd
graph rer lz lz_tnd
graph x_rir x_r x_r_tnd
graph pr prem
show output rir rer x_rir
graph gaps lgdp_gap_hp lgdp_gap
show gaps
